﻿using Microsoft.AspNetCore.Mvc;
using SiteStatus.Business;
using SiteStatus.Dbo;

namespace SiteStatus.Controllers
{

    [Route("api/[controller]")]
    [ApiController]
    public class StatusController : SSController
    {
        public DnsBusiness DnsBusiness { get; }
        public VpnBusiness VpnBusiness { get; }

        public StatusController(DnsBusiness dnsBusiness, VpnBusiness vpnBusiness)
        {
            DnsBusiness = dnsBusiness;
            VpnBusiness = vpnBusiness;
        }

        [HttpGet("/api/[controller]/vpn")]
        public ApiResultDbo<VpnStatusDbo> GetVpnStatus()
        {
            var result = VpnBusiness.GetVpnStatus();

            return Handle(result);
        }

        [HttpGet("/api/[controller]/dns")]
        public ApiResultDbo<DnsStatusDbo> GetDns()
        {
            var result = DnsBusiness.GetDnsStatus();

            return Handle(result);
        }
    }
}